=== debian/changelog ===
boinc-app-eah-brp (0.20170426+dfsg-2build2) artful; urgency=medium

  * No-change rebuild for libgsl soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 06 Aug 2017 01:08:19 +0000

boinc-app-eah-brp (0.20170426+dfsg-2build1) artful; urgency=medium

  * No-change rebuild against binutils 2.29

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 29 Jul 2017 10:30:39 -0700

boinc-app-eah-brp (0.20170426+dfsg-2) unstable; urgency=medium

  * Addressed compiler warnings.
  * Initial release (Closes: #861600).
  * Public redistribution as version 0.01 as set in debian/rules

 -- Steffen Moeller <moeller@debian.org>  Thu, 04 May 2017 09:28:07 +0200

boinc-app-eah-brp (0.20170426+dfsg-1) unstable; urgency=medium

  * First internal distribution.

 -- Steffen Moeller <moeller@debian.org>  Wed, 26 Apr 2017 23:44:15 +0200
